Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 136809 - portage incorreclty claims all dependencies are masked
Summary: portage incorreclty claims all dependencies are masked
Status: RESOLVED FIXED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core - Dependencies (show other bugs)
Hardware: x86 Linux
: High major (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: 155723 172589
  Show dependency tree
 
Reported: 2006-06-14 12:14 UTC by Joe Harvell
Modified: 2007-04-18 04:11 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge -1 -puDv --debug commons-pool (commons-pool.txt,52.78 KB, text/plain)
2006-06-15 09:43 UTC, Andy Lutomirski
Details
emerge -1 -pueDv --debug tomcat (tomcat.txt,40.11 KB, text/plain)
2006-06-15 09:43 UTC, Andy Lutomirski
Details
output from emerge -vauDN --debug world (emergeDebug.txt,97.51 KB, text/plain)
2006-06-15 12:03 UTC, Joe Harvell
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Joe Harvell 2006-06-14 12:14:00 UTC
sys-apps/lm_sensors-2.10.0 for x86 should have its dependencies satisfied by sys-apps/lm_sensors-modules (which I have installed).  However portage fails to build the dependency tree, claiming that virtual/linux-sources-2.5 is masked and  therefore lm_sensors-2.10.0 cannot have its dependencies satisfied

Related info:

1. I just upgraded to Portage 2.1.
2. I have been switching between the 2.4 profile and 2006.0 recently so that I could configure and test 2.6 versions of gentoo-sources, hotplug and udev.
3. I originally reported this problem under bug 136805, but I was complaining about the wrong behavior.

[excerpt from ebuild for lm_sensors-2.10.0]
DEPEND="${COMMON}
                sys-apps/sed
                ppc? ( >=virtual/linux-sources-2.5 )
                amd64? ( >=virtual/linux-sources-2.5 )
                x86? ( || ( >=virtual/linux-sources-2.5 sys-apps/lm_sensors-modules ) )"

[note lm_sensors-modules is installed]
# equery list lm_sensors
[ Searching for package 'lm_sensors' in all categories among: ]
 * installed packages
[I--] [  ] sys-apps/lm_sensors-2.10.0 (0)
[I--] [  ] sys-apps/lm_sensors-modules-2.10.0 (0)

[portage seems to be ignoring the fact that lm_sensors-modules satisfies the dependency]
# emerge -vauDN world

These are the packages that would be merged, in order:

Calculating world dependencies /
!!! All ebuilds that could satisfy ">=sys-kernel/gentoo-sources-2.5" have been masked.
!!! One of the following masked packages is required to complete your request:
- sys-kernel/gentoo-sources-2.6.15-r7 (masked by: profile, ~x86 keyword)
- sys-kernel/gentoo-sources-2.6.14-r7 (masked by: profile, ~x86 keyword)
- sys-kernel/gentoo-sources-2.6.15-r1 (masked by: profile)
- sys-kernel/gentoo-sources-2.6.16 (masked by: profile, ~x86 keyword)
- sys-kernel/gentoo-sources-2.6.15-r8 (masked by: profile, ~x86 keyword)
- sys-kernel/gentoo-sources-2.6.16-r7 (masked by: profile)
- sys-kernel/gentoo-sources-2.6.16-r6 (masked by: profile)
- sys-kernel/gentoo-sources-2.6.16-r5 (masked by: profile)
- sys-kernel/gentoo-sources-2.6.16-r4 (masked by: profile, ~x86 keyword)
- sys-kernel/gentoo-sources-2.6.16-r3 (masked by: profile)
- sys-kernel/gentoo-sources-2.6.16-r2 (masked by: profile, ~x86 keyword)
- sys-kernel/gentoo-sources-2.6.16-r1 (masked by: profile, ~x86 keyword)
- sys-kernel/gentoo-sources-2.6.16-r9 (masked by: profile)
- sys-kernel/gentoo-sources-2.6.16-r8 (masked by: profile, ~x86 keyword)

For more information, see MASKED PACKAGES section in the emerge man page or
refer to the Gentoo Handbook.
(dependency required by "sys-apps/lm_sensors-2.10.0" [ebuild])



!!! Problem resolving dependencies for kde-base/kde
!!! Depgraph creation failed.


#emerge --info
Portage 2.1 (default-linux/x86/no-nptl/2.4, gcc-3.4.6, glibc-2.3.6-r3, 2.4.32-gentoo-r4 i686)
=================================================================
System uname: 2.4.32-gentoo-r4 i686 Intel(R) Pentium(R) 4 CPU 2.60GHz
Gentoo Base System version 1.6.14
dev-lang/python:     2.4.2
dev-python/pycrypto: 2.0.1-r5
dev-util/ccache:     [Not Present]
dev-util/confcache:  [Not Present]
sys-apps/sandbox:    1.2.17
sys-devel/autoconf:  2.13, 2.59-r7
sys-devel/automake:  1.4_p6, 1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.6-r1
sys-devel/binutils:  2.16.1-r2
sys-devel/gcc-config: 1.3.13-r2
sys-devel/libtool:   1.5.22
virtual/os-headers:  2.4.26-r1
ACCEPT_KEYWORDS="x86"
AUTOCLEAN="yes"
CBUILD="i686-pc-linux-gnu"
CFLAGS="-O3 -march=pentium4 -pipe"
CHOST="i686-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/3.4/env /usr/kde/3.4/share/config /usr/kde/3.4/shutdown /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/lib/X11/xkb /usr/share/config"
CONFIG_PROTECT_MASK="/etc/env.d /etc/gconf /etc/revdep-rebuild /etc/terminfo"
CXXFLAGS="-O3 -march=pentium4 -pipe"
DISTDIR="/usr/portage/distfiles"
FEATURES="autoconfig distlocks metadata-transfer sandbox sfperms strict"
GENTOO_MIRRORS="http://gentoo.osuosl.org/ ftp://ftp.gtlib.gatech.edu/pub/gentoo ftp://mirror.iawnet.sandia.gov/pub/gentoo/ http://cudlug.cudenver.edu/gentoo/ "
MAKEOPTS="-j3"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --delete-after --stats --timeout=180 --exclude='/distfiles' --exclude='/local' --exclude='/packages'"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
SYNC="rsync://rsync.namerica.gentoo.org/gentoo-portage"
USE="x86 X acl acpi aim alsa apache2 arts avi bash-completion berkdb bitmap-fonts bzip2 calendar caps cdb cdparanoia cli crypt cups dedicated directfb doc dri dts dv dvb eds emacs emboss encode ethereal exif fbcon foomatic foomaticdb ftp gcj gdbm gif gphoto2 gpm gps gstreamer gtk gtk2 howl icq idn imagemagick imap imlib ipv6 isdnlog jabber java javascript jikes jpeg jpeg2k kde kdeenablefinal kdexdeltas ldap libg++ libwww lm_sensors mad mikmod mime mmap mmx motif mp3 mpeg msn ncurses nis nls nsplugin ogg opengl oscar oss pam pcre pdf pdflib perl plotutils png posix pppd python qt quicktime readline reflection samba sasl sdl session sharedmem sockets sox spell spl sse ssl svga sysvipc tcpd theora threads tiff truetype truetype-fonts type1-fonts unicode usb v4l videos vorbis win32codecs xine xinerama xml xml2 xmms xorg xosd xv xvid yahoo zlib elibc_glibc kernel_linux userland_GNU"
Unset:  CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LANG, LC_ALL, LDFLAGS, LINGUAS, PORTAGE_RSYNC_EXTRA_OPTS, PORTDIR_OVERLAY
Comment 1 Zac Medico gentoo-dev 2006-06-14 12:26:04 UTC
Please attach the ouput of the same command with --debug enabled.

To work around this, you can add a package that satisies the dependency to /etc/portage/package.provided like this:

mkdir -p /etc/portage/profile
echo sys-kernel/gentoo-sources-2.6.16-r9 >> /etc/portage/profile/package.provided
Comment 2 Alec Warner archtester Gentoo Infrastructure gentoo-dev Security 2006-06-14 17:19:20 UTC
# Copyright 1999-2006 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-x86/sys-apps/lm_sensors/lm_sensors-2.10.0.ebuild,v 1.3 2006/05/28 14
:57:00 brix Exp $

inherit eutils flag-o-matic linux-info toolchain-funcs multilib

That linux-info line means it has a dependency on some kernel sources.

From linux-info.eclass

DEPEND="kernel_linux? ( virtual/linux-sources )"
RDEPEND=""

default provider of linux-sources on x86 is probably, gentoo-sources.
Comment 3 Andy Lutomirski 2006-06-15 09:41:27 UTC
I think I triggered this bug on another set of packages.

dev-java/commons-pool-1.2 depends on >=virtual/jdk-1.3, which, on my system, is provided by blackdown:

# equery l -iop java     
[ Searching for package 'java' in all categories among: ]
 * installed packages
[I--] [  ] dev-java/java-config-1.2.11-r1 (0)
[I--] [  ] dev-java/javacup-0.10k (0)
[I--] [  ] dev-java/xjavac-20041208-r1 (1)
luto luto # equery l -iop jdk
[ Searching for package 'jdk' in all categories among: ]
 * installed packages
[I--] [  ] dev-java/blackdown-jdk-1.4.2.03 (1.4.2)
[I--] [M ] dev-java/sun-jdk-1.5.0.06-r2 (1.5)

Hence:

# emerge -1 -pv virtual/jdk

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R   ] dev-java/blackdown-jdk-1.4.2.03  USE="X alsa nsplugin -browserplugin -doc -mozilla*" 0 kB

# emerge -1 -pv commons-pool

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R   ] dev-java/commons-pool-1.2  USE="-doc -jikes -junit*" 0 kB

# emerge -1 -puDv commons-pool

These are the packages that would be merged, in order:

Calculating dependencies... done!

Total size of downloads: 0 kB

All this makes sence.  But here's the kicker:

# emerge -puDv world

These are the packages that would be merged, in order:

Calculating world dependencies |
!!! All ebuilds that could satisfy ">=dev-java/sun-jdk-1.3" have been masked.
!!! One of the following masked packages is required to complete your request:
- dev-java/sun-jdk-1.4.2.10-r2 (masked by: missing keyword)
- dev-java/sun-jdk-1.3.1.17 (masked by: missing keyword)
- dev-java/sun-jdk-1.5.0.06-r2 (masked by: ~amd64 keyword)
# <nichoj@gentoo.org>
# Many things in the tree don't compile with 1.5 yet.
# 1.5 defaults to -target 1.5, which makes downgrading to a 1.4/1.3
# impossible. See bug #69970 and bug 65937 for more information.
# http://www.gentoo.org/proj/en/java/tiger-faq.xml


For more information, see MASKED PACKAGES section in the emerge man page or
refer to the Gentoo Handbook.
(dependency required by "dev-java/commons-pool-1.2" [ebuild])



!!! Problem resolving dependencies for www-servers/tomcat
!!! Depgraph creation failed.

This one makes no sense.  Why does common-pool suddenly fail to notice blackdown?

Even weirder:

# emerge -1 -puDv tomcat

These are the packages that would be merged, in order:

Calculating dependencies... done!

Total size of downloads: 0 kB

Also, emerge -1 -peuDv commons-pool resolves OK (and chooses blackdown-jdk), but emerge -1 -pueDv tomcat gets the same error.

At the very least, this looks like a bug in the error messages.  As far as I can tell, however, it's a bug in the dependency generation.


# emerge --info
Portage 2.1 (default-linux/amd64/2006.0, gcc-4.1.1, glibc-2.3.6-r3, 2.6.16-gentoo-r9 x86_64)
=================================================================
System uname: 2.6.16-gentoo-r9 x86_64 AMD Athlon(tm) 64 Processor 3200+
Gentoo Base System version 1.6.14
ccache version 2.3 [disabled]
dev-lang/python:     2.4.2
dev-python/pycrypto: 2.0.1-r5
dev-util/ccache:     2.3
dev-util/confcache:  [Not Present]
sys-apps/sandbox:    1.2.17
sys-devel/autoconf:  2.13, 2.59-r7
sys-devel/automake:  1.4_p6, 1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.6-r1
sys-devel/binutils:  2.16.1-r2
sys-devel/gcc-config: 1.3.13-r2
sys-devel/libtool:   1.5.22
virtual/os-headers:  2.6.16
ACCEPT_KEYWORDS="amd64"
AUTOCLEAN="yes"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=k8 -O3 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/boot/grub:/usr/lib/perl5/vendor_perl/5.8.4/Netcomics/etc /etc /usr/kde/3.4/env /usr/kde/3.4/share/config /usr/kde/3.4/shutdown /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/lib/X11/xkb /usr/lib64/mozilla/defaults/pref /usr/share/config /usr/share/texmf/dvipdfm/config/ /usr/share/texmf/dvips/config/ /usr/share/texmf/tex/generic/config/ /usr/share/texmf/tex/platex/config/ /usr/share/texmf/xdvi/ /var/bind"
CONFIG_PROTECT_MASK="/etc/env.d /etc/gconf /etc/terminfo"
CXXFLAGS="-march=k8 -O3 -pipe"
DISTDIR="/usr/portage/distfiles"
FEATURES="autoconfig buildpkg distlocks metadata-transfer parallel-fetch sandbox sfperms strict userpriv usersandbox"
GENTOO_MIRRORS="http://gentoo.chem.wisc.edu/gentoo/ http://gentoo.mirrors.pair.com/ http://gentoo.osuosl.org"
MAKEOPTS="-j2"
PKGDIR="/var/tmp/safe/portage-pkg"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --delete-after --stats --timeout=180 --exclude='/distfiles' --exclude='/local' --exclude='/packages'"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="amd64 X acl alsa apache2 avi berkdb bitmap-fonts boo cairo cli crypt cups dri dvd eds emboss encode f77 foomaticdb fortran gcj gif glitz gnome gpm gstreamer gtk gtk2 imlib ipv6 isdnlog ithreads java jpeg kde kdehiddenvisibility kerberos krb4 lzw lzw-tiff mono mozsvg mp3 mpeg ncurses network nls nptl nptlonly nsplugin opengl pam pcre pdflib perl png pppd python qt quicktime readline reflection sasl sdl session spell spl ssl tcpd threads tiff truetype truetype-fonts type1-fonts usb v4l2 vhosts xorg xpm xv xvid zlib elibc_glibc kernel_linux userland_GNU"
Unset:  CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LANG, LC_ALL, LDFLAGS, LINGUAS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 4 Andy Lutomirski 2006-06-15 09:43:18 UTC
Created attachment 89254 [details]
emerge -1 -puDv --debug commons-pool

Debug output from a working case
Comment 5 Andy Lutomirski 2006-06-15 09:43:54 UTC
Created attachment 89255 [details]
emerge -1 -pueDv --debug tomcat

Debug output from a non-working case
Comment 6 Joe Harvell 2006-06-15 12:03:12 UTC
Created attachment 89260 [details]
output from emerge -vauDN --debug world
Comment 7 Joe Harvell 2006-06-15 12:08:02 UTC
(In reply to comment #2)
> # Copyright 1999-2006 Gentoo Foundation
> # Distributed under the terms of the GNU General Public License v2
> # $Header:
> /var/cvsroot/gentoo-x86/sys-apps/lm_sensors/lm_sensors-2.10.0.ebuild,v 1.3
> 2006/05/28 14
> :57:00 brix Exp $
> 
> inherit eutils flag-o-matic linux-info toolchain-funcs multilib
> 
> That linux-info line means it has a dependency on some kernel sources.
> 
> From linux-info.eclass
> 
> DEPEND="kernel_linux? ( virtual/linux-sources )"
> RDEPEND=""
> 
> default provider of linux-sources on x86 is probably, gentoo-sources.
> 

So I have both an unmasked and a masked version of gentoo-sources installed.  Remember from my original problem description that I mentioned I temporarily switched profiles to 2006.0 so I could install the 2.6 version.

Even so, I do have an unmasked version of gentoo-sources.  So virtual/linux-sources should be met.

$ equery list -i gentoo-sources
[ Searching for package 'gentoo-sources' in all categories among: ]
 * installed packages
[I--] [  ] sys-kernel/gentoo-sources-2.4.32-r4 (2.4.32-r4)
[I--] [M ] sys-kernel/gentoo-sources-2.6.16-r9 (2.6.16-r9)
Comment 8 Andy Lutomirski 2006-06-15 14:24:14 UTC
(In reply to comment #7)
> So I have both an unmasked and a masked version of gentoo-sources installed. 
> Remember from my original problem description that I mentioned I temporarily
> switched profiles to 2006.0 so I could install the 2.6 version.
> 
> Even so, I do have an unmasked version of gentoo-sources.  So
> virtual/linux-sources should be met.

Ah -- I have the same thing.  I have dev-java/sun-jdk-1.5.0.06-r2 (masked) and 
dev-java/blackdown-jdk-1.4.2.03 (unmasked), either of which should satisfy
virtual/jdk.

Note that this seemed to work fine before Portage 2.1, I think.

Comment 9 Zac Medico gentoo-dev 2007-04-18 04:11:38 UTC
This is fixed in 2.1.2.3.